import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.dayou.BaseApplication;
import com.dayou.bo.HeadlineTreeBO;
import com.dayou.bo.LeaderRatioBO;
import com.dayou.bo.Tree;
import com.dayou.configuration.AsyncManager;
import com.dayou.controller.ItemController;
import com.dayou.dto.BaseReport;
import com.dayou.dto.DeductionDTO;
import com.dayou.dto.ItemDTO;
import com.dayou.entity.*;
import com.dayou.mapper.ItemBrokerageTechnicistDeductionMapper;
import com.dayou.report.ReportServer;
import com.dayou.service.*;
import com.dayou.service.impl.ItemBrokerageSequenceServiceImpl;
import com.dayou.utils.ConvertUtil;
import com.dayou.utils.Md5Utils;
import com.dayou.vo.ItemStageVO;
import com.dayou.vo.ItemStatVO;
import com.deepoove.poi.config.Configure;
import com.deepoove.poi.data.*;
import com.deepoove.poi.data.style.Style;
import com.deepoove.poi.policy.DocumentRenderPolicy;
import com.google.common.cache.Cache;
import com.google.common.cache.LoadingCache;
import com.google.common.collect.Lists;
import com.zaxxer.hikari.HikariDataSource;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.RandomUtils;
import org.checkerframework.checker.units.qual.A;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.ApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.*;
import java.util.concurrent.ExecutionException;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.ToDoubleFunction;
import java.util.stream.Collectors;

/**
 * 类说明：
 *
 * @author: wucl
 * @since: 2023/3/6
 * created with IntelliJ IDEA.
 */
@Slf4j
@SpringBootTest(classes = BaseApplication.class)
@RunWith(SpringJUnit4ClassRunner.class)
public class BrokerageTest {

    @Autowired
    private ITeamMemberService teamMemberService;

    @Autowired
    private IItemBrokerageGeneralService iItemBrokerageGeneralService;

    @Autowired
    private IItemStageService itemStageService;

    @Autowired
    private IItemBrokerageSequenceService itemBrokerageSequenceService;

    @Autowired
    private ItemBrokerageTechnicistDeductionMapper deductionMapper;

    @Autowired
    private IItemBrokerageTechnicistService technicistService;

    @Autowired
    private ReportServer reportServer;

    @Autowired
    private IReportHeadlineService reportHeadlineService;




//    @Test
//    public void generalBatchBrokerage() throws ExecutionException {
//        ArrayList<Long> itemIds = Lists.newArrayList(
//              320L
//        );
//
//        for (Long itemId : itemIds){
//            iItemBrokerageGeneralService.addMarketerBrokerage(itemId);
//            List<ItemStageVO> itemStageVOS = itemStageService.listByItemId(itemId);
//            if (CollectionUtils.isNotEmpty(itemStageVOS)){
//                for (ItemStageVO itemStageVO :itemStageVOS){
//                    if (itemStageVO!=null && itemStageVO.getId()!=null){
//
//                        iItemBrokerageGeneralService.addParticipatorBrokerage(itemStageVO,itemStageVO.getId());
//                    }
//                }
//            }
//        }
//    }
//
//
//    @Test
//    public void settle(){
//        Boolean result = itemBrokerageSequenceService.doAbleItemBrokerageSettle();
//        //Boolean nonResult = itemBrokerageSequenceService.doNonMarketerAheadSettle();
//        Assert.isTrue(result);
//    }
//    @Test
//    public void test(){
//        List<DeductionDTO> deductionDTOS = deductionMapper.notDeductionDefaultSettle(112L);
//        List<ItemBrokerageTechnicist> technicistsBrokerages = technicistService.list(new LambdaQueryWrapper<ItemBrokerageTechnicist>().eq(ItemBrokerageTechnicist::getUserId, 112L).gt(ItemBrokerageTechnicist::getResidueAmount,BigDecimal.ZERO));
//        itemBrokerageSequenceService.deduction(technicistsBrokerages,deductionDTOS);
////        ItemBrokerageSequence byId = itemBrokerageSequenceService.getById(189L);
////        itemBrokerageSequenceService.extracted(new BigDecimal("5000"),byId,technicistsBrokerages);
//    }

    @Test
    public void output(){

        List<ReportHeadline> list = reportHeadlineService.getHeadline(1L);
        List<HeadlineTreeBO> headlineTreeBOS = ConvertUtil.copyList(list, HeadlineTreeBO.class);
        List<HeadlineTreeBO> headlineTree = (List<HeadlineTreeBO>) buildTree(headlineTreeBOS,1L);
        List<TextRenderData> allHeadline = new ArrayList<>();
        //allHeadline = findHeadline(allHeadline, headlineTree);
        String [] members =  {"何  强（项目经理）","何  帆（项目助理）", "李丽丽（项目助理）","蒋益春（项目助理）"};
        ArrayList<String> strings = Lists.newArrayList(members);
        BaseReport baseReport = BaseReport.builder().reportType("社会稳定风险评估报告")
                        .itemName("兴文县2023年第3批次建设用地征收项目")
                                .companyName("四川大友房地产土地资产评估有限公司")
                                        .yearMonthUppercase("二〇二三年二月")
                                                .clientUnit("兴文县征地拆迁服务中心")
                                                        .yearMonthLowercase("2023年2月")
                                                                .principalAndTitle("王亚明（总经理）")
                                                                        .memberAndTitles(strings)
                                                                                .checkerAndTitle("何  英（信息复审部经理）")
                                                                                        .introduction("根据中共中央办公厅、国务院办公厅《关于<加强新形势下重大决策社会稳定风险评估机制建设的意见>的通知》（中办发〔2021〕11号）、《四川省重大决策社会稳定风险评估办法》（川委办〔2022〕2号）等文件要求，兴文县2023年第3批次建设用地征收项目涉及的集体土地征收，涉及群众切身利益，应当开展社会稳定风险评估。受项目单位兴文县征地拆迁服务中心的委托，由我公司（四川大友房地产土地资产评估有限公司）承担《兴文县2023年第3批次建设用地征收项目社会稳定风险评估报告》的编制工作。\n" +
                                                                                                "我公司接受委托后立即成立了评估小组，查阅了项目相关的初步设计等资料，深入了解项目周边的社会、环境情况，深入分析项目潜在的社会稳定风险因素，提出相应的风险防范措施，根据《国家发展改革委办公厅关于印发重大固定资产投资项目社会稳定风险分析篇章和评估报告编制大纲（试行）的通知》（发改办投资〔2013〕428号）、《四川省重大决策社会稳定风险评估办法》（川委办〔2022〕2号）等文件的要求，在兴文县政府办、县自规局、县委政法委等部门及古宋镇人民政府、古宋镇甘洞湾村村委等乡镇领导的指导下，在项目单位的配合下，编制完成了《兴文县2023年第3批次建设用地征收项目社会稳定风险评估报告》。\n")
                                                                                                .evaluateDate(new Date())
//                                                                                                        .baseContentLabel(allHeadline)
                .catalogue("todo").build();
        baseReport.setTitles(Includes.ofLocal("src/main/resources/report_template/land/risk/headline_1.docx").setRenderModel(headlineTree).create());
        try {
            reportServer.loadBaseTemplate(baseReport);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }

    @Test
    public void transforPDF(){
        try {
            reportServer.loadBaseTemplate(null);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public List<TextRenderData> findHeadline(List<TextRenderData> allHeadline,List<HeadlineTreeBO> list){
        Style title1 = Style.builder().buildFontFamily("宋体").buildFontSize(22d).buildBold().build();
        Style title2 = Style.builder().buildFontFamily("宋体").buildFontSize(16d).buildBold().build();
        Style paragraph = Style.builder().buildFontFamily("宋体").buildFontSize(14d).build();

        for (HeadlineTreeBO headlineTreeBO : list){
            TextRenderData paragraphRender = new TextRenderData("{{placeholder"+headlineTreeBO.getHeadlineNum()+"}}",paragraph);
            String xHeadline = headlineTreeBO.getHeadlineNum() + headlineTreeBO.getHeadline();
            TextRenderData renderData = new TextRenderData(xHeadline);
            if (headlineTreeBO.getLevel()==1){
                renderData.setStyle(title1);
            }
            else {
                renderData.setStyle(title2);
            }
            allHeadline.add(renderData);
            allHeadline.add(paragraphRender);
            List<HeadlineTreeBO> children = headlineTreeBO.getChildren();
            if (CollectionUtils.isNotEmpty(children)){
                findHeadline(allHeadline,children);
            }
        }
        return allHeadline;
    }
    public static<K,V> List<? extends Tree<K,V>> buildTree(Collection<? extends Tree<K,V>> list,Long rootId){
        List<Tree<K, V>> trees = new LinkedList<>();

        if(org.apache.commons.collections4.CollectionUtils.isEmpty(list)){
            return trees;
        }

        //找出所有根节点
        List<? extends Tree<K,V>>  root = null;
        if (rootId!=null){
            root =  list.stream().filter(t->(t.getParentId().equals(rootId))).collect(Collectors.toList());
        }else {
            root = list.stream().filter(t->(t.getParentId()==null||t.getParentId().equals(0L))).collect(Collectors.toList());
        }
        if(CollectionUtils.isNotEmpty(root)){
            Collections.sort(root,(o1, o2) -> o1.order() - o2.order());
            //为每个节点找出它的children
            for (Tree<K,V> leaf:root){
                findChildren(leaf,list);
                trees.add(leaf);
            }
        }

        return trees;
    }

    private static<K,V> void findChildren(Tree<K,V> leaf, Collection<? extends Tree<K,V>> list) {
        K id=leaf.getId();
        List<? extends Tree<K,V>> children = list.stream().filter(t->id.equals(t.getParentId())).collect(Collectors.toList());
        if(CollectionUtils.isNotEmpty(children)){
            Collections.sort(children,(o1, o2) -> o1.order() - o2.order());
            leaf.setChildren(children);
        }
        list = list.stream().filter(t->!id.equals(t.getId())).collect(Collectors.toList());
        if(CollectionUtils.isNotEmpty(children)){
            for(Tree<K,V> subLeaf:children){
                findChildren(subLeaf, list);
            }
        }
    }
}