package com.dayou.entity;
import com.dayou.common.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.dayou.annotation.ExcelSheet;
import com.dayou.annotation.ExportCell;
import com.dayou.annotation.ImportCell;
/**
 * <p>
 * 报告段落模板
 * </p>
 *
 * @author wucl
 * @since 2023-08-25
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ExcelSheet(sheetName = "报告段落模板")
public class ReportSection extends BaseEntity {

    private static final long serialVersionUID=1L;

    /**
     * 报告标题id
     */
    private Long headlineId;

    /**
     * 段落内容
     */
    @ImportCell
    @ExportCell(columnName = "段落内容")
    private String section;

    /**
     * 自定义名称
     */
    @ImportCell
    @ExportCell(columnName = "自定义名称")
    private String name;

    /**
     * 创建人id
     */
    private Long userId;


}
