package com.dayou.service.impl;

import com.dayou.entity.ReportSection;
import com.dayou.mapper.ReportSectionMapper;
import com.dayou.service.IReportSectionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dayou.utils.ExcelUtil;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.web.multipart.MultipartFile;
import java.util.List;
import java.util.ArrayList;
import org.springframework.transaction.annotation.Transactional;
import com.dayou.enums.BatchTaskTypeEnum;

/**
 * <p>
 * 报告段落模板 服务实现类
 * </p>
 *
 * @author wucl
 * @since 2023-08-25
 */
@Service
public class ReportSectionServiceImpl extends ServiceImpl<ReportSectionMapper, ReportSection> implements IReportSectionService {


    @Override
    @SuppressWarnings("unchecked")
    public Page<ReportSection> selectPage(Page page,ReportSection reportSection){
        return this.page(page, new QueryWrapper<ReportSection>(reportSection));
    }


    @Override
    public ReportSection detail(Long id){
        return this.getById(id);
    }

    @Override
    public Boolean add(ReportSection reportSection){
        return  this.save(reportSection);
    }

    @Override
    public Boolean update(ReportSection reportSection){
        return  this.updateById(reportSection);
    }

    @Override
    public Boolean delete(Long id){
        //逻辑删除
        return this.removeById(id);
    }
}
